-- TTRoleIcon for RIFT by Vritra

local TTRI = {}
local Loaded = false
local LastUpdate = (Inspect.Time.Frame() or 0) + 2
local UPDATE = .08
local LastRole = ""

table.insert(Event.System.Update.Begin, {function()
	local now = Inspect.Time.Frame()
	if (now - LastUpdate) > UPDATE then
		LastUpdate = now
	else
		return
	end

	if Loaded == false then
		local h = UI.Native.PortraitTargetTarget:GetHeight()
		if h then
			TTRI.Context = UI.CreateContext("TTRoleIcon")

			TTRI.IcoFrame = UI.CreateFrame("Frame", "IconFrame", TTRI.Context)
			TTRI.IcoFrame:SetPoint(0,0, UI.Native.PortraitTargetTarget, .85,.1)
			TTRI.IcoFrame:SetHeight(h/6)
			TTRI.IcoFrame:SetWidth(h/6)

			TTRI.Icons = {}
			TTRI.Icons.tank = UI.CreateFrame("Texture", "IconTank", TTRI.IcoFrame)
			TTRI.Icons.heal = UI.CreateFrame("Texture", "IconHeal", TTRI.IcoFrame)
			TTRI.Icons.support = UI.CreateFrame("Texture", "IconSupport", TTRI.IcoFrame)
			TTRI.Icons.dps = UI.CreateFrame("Texture", "IconDPS", TTRI.IcoFrame)
			for k, v in pairs(TTRI.Icons) do
				v:SetAllPoints(TTRI.IcoFrame)
				v:SetTexture("TTRoleIcon", "role_"..k..".png")
			end
			Loaded = true
		else
			return
		end
	end

	local function GetDetail(unit, member)
		local d = Inspect.Unit.Detail(unit) or false
		if d then
			for k, v in pairs(d) do
				if k == member then
					return(v)
				end
			end
		end
	end

	local role = GetDetail("player.target.target", "role")
	if role == LastRole then
		return
	end
	LastRole = role
	if role then
		for k, v in pairs(TTRI.Icons) do
			v:SetVisible(k == role)
		end
		TTRI.IcoFrame:SetVisible(true)
	else
		TTRI.IcoFrame:SetVisible(false)
	end
end, "TTRoleIcon", "Update"})
